<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_65) on Fri Aug 22 15:06:29 CEST 2014 -->
<title>WebSocketListener</title>
<meta name="date" content="2014-08-22">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="WebSocketListener";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/WebSocketListener.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../org/java_websocket/WebSocketImpl.html" title="class in org.java_websocket"><span class="strong">Prev Class</span></a></li>
<li><a href="../../org/java_websocket/WrappedByteChannel.html" title="interface in org.java_websocket"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?org/java_websocket/WebSocketListener.html" target="_top">Frames</a></li>
<li><a href="WebSocketListener.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.java_websocket</div>
<h2 title="Interface WebSocketListener" class="title">Interface WebSocketListener</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Known Implementing Classes:</dt>
<dd><a href="../../fr/inria/alpage/frmgcm/server/FRMGWebSocketServer.html" title="class in fr.inria.alpage.frmgcm.server">FRMGWebSocketServer</a>, <a href="../../org/java_websocket/WebSocketAdapter.html" title="class in org.java_websocket">WebSocketAdapter</a>, <a href="../../org/java_websocket/client/WebSocketClient.html" title="class in org.java_websocket.client">WebSocketClient</a>, <a href="../../org/java_websocket/server/WebSocketServer.html" title="class in org.java_websocket.server">WebSocketServer</a></dd>
</dl>
<hr>
<br>
<pre>public interface <span class="strong">WebSocketListener</span></pre>
<div class="block">Implemented by <tt>WebSocketClient</tt> and <tt>WebSocketServer</tt>.
 The methods within are called by <tt>WebSocket</tt>.
 Almost every method takes a first parameter conn which represents the source of the respective event.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#getFlashPolicy(org.java_websocket.WebSocket)">getFlashPolicy</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</code>
<div class="block">Gets the XML string that should be returned if a client requests a Flash
 security policy.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.net.InetSocketAddress</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#getLocalSocketAddress(org.java_websocket.WebSocket)">getLocalSocketAddress</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.net.InetSocketAddress</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#getRemoteSocketAddress(org.java_websocket.WebSocket)">getRemoteSocketAddress</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWebsocketClose(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">onWebsocketClose</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;ws,
                int&nbsp;code,
                java.lang.String&nbsp;reason,
                boolean&nbsp;remote)</code>
<div class="block">Called after <tt>WebSocket#close</tt> is explicity called, or when the
 other end of the WebSocket connection is closed.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWebsocketCloseInitiated(org.java_websocket.WebSocket,%20int,%20java.lang.String)">onWebsocketCloseInitiated</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;ws,
                         int&nbsp;code,
                         java.lang.String&nbsp;reason)</code>
<div class="block">send when this peer sends a close handshake</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWebsocketClosing(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">onWebsocketClosing</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;ws,
                  int&nbsp;code,
                  java.lang.String&nbsp;reason,
                  boolean&nbsp;remote)</code>
<div class="block">called as soon as no further frames are accepted</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWebsocketError(org.java_websocket.WebSocket,%20java.lang.Exception)">onWebsocketError</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                java.lang.Exception&nbsp;ex)</code>
<div class="block">Called if an exception worth noting occurred.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWebsocketHandshakeReceivedAsClient(org.java_websocket.WebSocket,%20org.java_websocket.handshake.ClientHandshake,%20org.java_websocket.handshake.ServerHandshake)">onWebsocketHandshakeReceivedAsClient</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                                    <a href="../../org/java_websocket/handshake/ClientHandshake.html" title="interface in org.java_websocket.handshake">ClientHandshake</a>&nbsp;request,
                                    <a href="../../org/java_websocket/handshake/ServerHandshake.html" title="interface in org.java_websocket.handshake">ServerHandshake</a>&nbsp;response)</code>
<div class="block">Called on the client side when the socket connection is first established, and the WebSocketImpl
 handshake response has been received.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../org/java_websocket/handshake/ServerHandshakeBuilder.html" title="interface in org.java_websocket.handshake">ServerHandshakeBuilder</a></code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWebsocketHandshakeReceivedAsServer(org.java_websocket.WebSocket,%20org.java_websocket.drafts.Draft,%20org.java_websocket.handshake.ClientHandshake)">onWebsocketHandshakeReceivedAsServer</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                                    <a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;draft,
                                    <a href="../../org/java_websocket/handshake/ClientHandshake.html" title="interface in org.java_websocket.handshake">ClientHandshake</a>&nbsp;request)</code>
<div class="block">Called on the server side when the socket connection is first established, and the WebSocket
 handshake has been received.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWebsocketHandshakeSentAsClient(org.java_websocket.WebSocket,%20org.java_websocket.handshake.ClientHandshake)">onWebsocketHandshakeSentAsClient</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                                <a href="../../org/java_websocket/handshake/ClientHandshake.html" title="interface in org.java_websocket.handshake">ClientHandshake</a>&nbsp;request)</code>
<div class="block">Called on the client side when the socket connection is first established, and the WebSocketImpl
 handshake has just been sent.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWebsocketMessage(org.java_websocket.WebSocket,%20java.nio.ByteBuffer)">onWebsocketMessage</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                  java.nio.ByteBuffer&nbsp;blob)</code>
<div class="block">Called when an entire binary frame has been received.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWebsocketMessage(org.java_websocket.WebSocket,%20java.lang.String)">onWebsocketMessage</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                  java.lang.String&nbsp;message)</code>
<div class="block">Called when an entire text frame has been received.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWebsocketMessageFragment(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onWebsocketMessageFragment</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                          <a href="../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;frame)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWebsocketOpen(org.java_websocket.WebSocket,%20org.java_websocket.handshake.Handshakedata)">onWebsocketOpen</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
               <a href="../../org/java_websocket/handshake/Handshakedata.html" title="interface in org.java_websocket.handshake">Handshakedata</a>&nbsp;d)</code>
<div class="block">Called after <var>onHandshakeReceived</var> returns <var>true</var>.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWebsocketPing(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onWebsocketPing</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
               <a href="../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;f)</code>
<div class="block">Called a ping frame has been received.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWebsocketPong(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onWebsocketPong</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
               <a href="../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;f)</code>
<div class="block">Called when a pong frame is received.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/WebSocketListener.html#onWriteDemand(org.java_websocket.WebSocket)">onWriteDemand</a></strong>(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</code>
<div class="block">This method is used to inform the selector thread that there is data queued to be written to the socket.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="onWebsocketHandshakeReceivedAsServer(org.java_websocket.WebSocket, org.java_websocket.drafts.Draft, org.java_websocket.handshake.ClientHandshake)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketHandshakeReceivedAsServer</h4>
<pre><a href="../../org/java_websocket/handshake/ServerHandshakeBuilder.html" title="interface in org.java_websocket.handshake">ServerHandshakeBuilder</a>&nbsp;onWebsocketHandshakeReceivedAsServer(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                                                          <a href="../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;draft,
                                                          <a href="../../org/java_websocket/handshake/ClientHandshake.html" title="interface in org.java_websocket.handshake">ClientHandshake</a>&nbsp;request)
                                                            throws <a href="../../org/java_websocket/exceptions/InvalidDataException.html" title="class in org.java_websocket.exceptions">InvalidDataException</a></pre>
<div class="block">Called on the server side when the socket connection is first established, and the WebSocket
 handshake has been received. This method allows to deny connections based on the received handshake.<br>
 By default this method only requires protocol compliance.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The WebSocket related to this event</dd><dd><code>draft</code> - The protocol draft the client uses to connect</dd><dd><code>request</code> - The opening http message send by the client. Can be used to access additional fields like cookies.</dd>
<dt><span class="strong">Returns:</span></dt><dd>Returns an incomplete handshake containing all optional fields</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../org/java_websocket/exceptions/InvalidDataException.html" title="class in org.java_websocket.exceptions">InvalidDataException</a></code> - Throwing this exception will cause this handshake to be rejected</dd></dl>
</li>
</ul>
<a name="onWebsocketHandshakeReceivedAsClient(org.java_websocket.WebSocket, org.java_websocket.handshake.ClientHandshake, org.java_websocket.handshake.ServerHandshake)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketHandshakeReceivedAsClient</h4>
<pre>void&nbsp;onWebsocketHandshakeReceivedAsClient(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                                        <a href="../../org/java_websocket/handshake/ClientHandshake.html" title="interface in org.java_websocket.handshake">ClientHandshake</a>&nbsp;request,
                                        <a href="../../org/java_websocket/handshake/ServerHandshake.html" title="interface in org.java_websocket.handshake">ServerHandshake</a>&nbsp;response)
                                          throws <a href="../../org/java_websocket/exceptions/InvalidDataException.html" title="class in org.java_websocket.exceptions">InvalidDataException</a></pre>
<div class="block">Called on the client side when the socket connection is first established, and the WebSocketImpl
 handshake response has been received.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The WebSocket related to this event</dd><dd><code>request</code> - The handshake initially send out to the server by this websocket.</dd><dd><code>response</code> - The handshake the server sent in response to the request.</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../org/java_websocket/exceptions/InvalidDataException.html" title="class in org.java_websocket.exceptions">InvalidDataException</a></code> - Allows the client to reject the connection with the server in respect of its handshake response.</dd></dl>
</li>
</ul>
<a name="onWebsocketHandshakeSentAsClient(org.java_websocket.WebSocket, org.java_websocket.handshake.ClientHandshake)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketHandshakeSentAsClient</h4>
<pre>void&nbsp;onWebsocketHandshakeSentAsClient(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                                    <a href="../../org/java_websocket/handshake/ClientHandshake.html" title="interface in org.java_websocket.handshake">ClientHandshake</a>&nbsp;request)
                                      throws <a href="../../org/java_websocket/exceptions/InvalidDataException.html" title="class in org.java_websocket.exceptions">InvalidDataException</a></pre>
<div class="block">Called on the client side when the socket connection is first established, and the WebSocketImpl
 handshake has just been sent.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The WebSocket related to this event</dd><dd><code>request</code> - The handshake sent to the server by this websocket</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../org/java_websocket/exceptions/InvalidDataException.html" title="class in org.java_websocket.exceptions">InvalidDataException</a></code> - Allows the client to stop the connection from progressing</dd></dl>
</li>
</ul>
<a name="onWebsocketMessage(org.java_websocket.WebSocket, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketMessage</h4>
<pre>void&nbsp;onWebsocketMessage(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                      java.lang.String&nbsp;message)</pre>
<div class="block">Called when an entire text frame has been received. Do whatever you want
 here...</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The <tt>WebSocket</tt> instance this event is occurring on.</dd><dd><code>message</code> - The UTF-8 decoded message that was received.</dd></dl>
</li>
</ul>
<a name="onWebsocketMessage(org.java_websocket.WebSocket, java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketMessage</h4>
<pre>void&nbsp;onWebsocketMessage(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                      java.nio.ByteBuffer&nbsp;blob)</pre>
<div class="block">Called when an entire binary frame has been received. Do whatever you want
 here...</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The <tt>WebSocket</tt> instance this event is occurring on.</dd><dd><code>blob</code> - The binary message that was received.</dd></dl>
</li>
</ul>
<a name="onWebsocketMessageFragment(org.java_websocket.WebSocket, org.java_websocket.framing.Framedata)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketMessageFragment</h4>
<pre>void&nbsp;onWebsocketMessageFragment(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                              <a href="../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;frame)</pre>
</li>
</ul>
<a name="onWebsocketOpen(org.java_websocket.WebSocket, org.java_websocket.handshake.Handshakedata)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketOpen</h4>
<pre>void&nbsp;onWebsocketOpen(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                   <a href="../../org/java_websocket/handshake/Handshakedata.html" title="interface in org.java_websocket.handshake">Handshakedata</a>&nbsp;d)</pre>
<div class="block">Called after <var>onHandshakeReceived</var> returns <var>true</var>.
 Indicates that a complete WebSocket connection has been established,
 and we are ready to send/receive data.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The <tt>WebSocket</tt> instance this event is occuring on.</dd></dl>
</li>
</ul>
<a name="onWebsocketClose(org.java_websocket.WebSocket, int, java.lang.String, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketClose</h4>
<pre>void&nbsp;onWebsocketClose(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;ws,
                    int&nbsp;code,
                    java.lang.String&nbsp;reason,
                    boolean&nbsp;remote)</pre>
<div class="block">Called after <tt>WebSocket#close</tt> is explicity called, or when the
 other end of the WebSocket connection is closed.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The <tt>WebSocket</tt> instance this event is occuring on.</dd></dl>
</li>
</ul>
<a name="onWebsocketClosing(org.java_websocket.WebSocket, int, java.lang.String, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketClosing</h4>
<pre>void&nbsp;onWebsocketClosing(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;ws,
                      int&nbsp;code,
                      java.lang.String&nbsp;reason,
                      boolean&nbsp;remote)</pre>
<div class="block">called as soon as no further frames are accepted</div>
</li>
</ul>
<a name="onWebsocketCloseInitiated(org.java_websocket.WebSocket, int, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketCloseInitiated</h4>
<pre>void&nbsp;onWebsocketCloseInitiated(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;ws,
                             int&nbsp;code,
                             java.lang.String&nbsp;reason)</pre>
<div class="block">send when this peer sends a close handshake</div>
</li>
</ul>
<a name="onWebsocketError(org.java_websocket.WebSocket, java.lang.Exception)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketError</h4>
<pre>void&nbsp;onWebsocketError(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                    java.lang.Exception&nbsp;ex)</pre>
<div class="block">Called if an exception worth noting occurred.
 If an error causes the connection to fail onClose will be called additionally afterwards.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>ex</code> - The exception that occurred. <br>
            Might be null if the exception is not related to any specific connection. For example if the server port could not be bound.</dd></dl>
</li>
</ul>
<a name="onWebsocketPing(org.java_websocket.WebSocket, org.java_websocket.framing.Framedata)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketPing</h4>
<pre>void&nbsp;onWebsocketPing(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                   <a href="../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;f)</pre>
<div class="block">Called a ping frame has been received.
 This method must send a corresponding pong by itself.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>f</code> - The ping frame. Control frames may contain payload.</dd></dl>
</li>
</ul>
<a name="onWebsocketPong(org.java_websocket.WebSocket, org.java_websocket.framing.Framedata)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketPong</h4>
<pre>void&nbsp;onWebsocketPong(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                   <a href="../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;f)</pre>
<div class="block">Called when a pong frame is received.</div>
</li>
</ul>
<a name="getFlashPolicy(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getFlashPolicy</h4>
<pre>java.lang.String&nbsp;getFlashPolicy(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)
                                throws <a href="../../org/java_websocket/exceptions/InvalidDataException.html" title="class in org.java_websocket.exceptions">InvalidDataException</a></pre>
<div class="block">Gets the XML string that should be returned if a client requests a Flash
 security policy.</div>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../org/java_websocket/exceptions/InvalidDataException.html" title="class in org.java_websocket.exceptions">InvalidDataException</a></code> - thrown when some data that is required to generate the flash-policy like the websocket local port could not be obtained.</dd></dl>
</li>
</ul>
<a name="onWriteDemand(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWriteDemand</h4>
<pre>void&nbsp;onWriteDemand(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</pre>
<div class="block">This method is used to inform the selector thread that there is data queued to be written to the socket.</div>
</li>
</ul>
<a name="getLocalSocketAddress(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getLocalSocketAddress</h4>
<pre>java.net.InetSocketAddress&nbsp;getLocalSocketAddress(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</pre>
</li>
</ul>
<a name="getRemoteSocketAddress(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getRemoteSocketAddress</h4>
<pre>java.net.InetSocketAddress&nbsp;getRemoteSocketAddress(<a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</pre>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/WebSocketListener.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../org/java_websocket/WebSocketImpl.html" title="class in org.java_websocket"><span class="strong">Prev Class</span></a></li>
<li><a href="../../org/java_websocket/WrappedByteChannel.html" title="interface in org.java_websocket"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?org/java_websocket/WebSocketListener.html" target="_top">Frames</a></li>
<li><a href="WebSocketListener.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
